local T, C, L, _ = unpack(select(2, ...))
if T.client ~= "zhCN" or not T.classic then return end

----------------------------------------------------------------------------------------
--	LiteStats configuration file
--	BACKUP THIS FILE BEFORE UPDATING!
----------------------------------------------------------------------------------------
local cBN = IsAddOnLoaded("cargBags_Nivaya")
local ctab = CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS
local function class(string)
	local color = ctab[T.class]
	return format("|cff%02x%02x%02x%s|r", color.r * 255, color.g * 255, color.b * 255, string or "")
end

LPSTAT_FONT = {
	font = C.font.stats_font,				-- Path to your font
	color = {1, 1, 1},						-- {red, green, blue} or "CLASS"
	size = C.font.stats_font_size,			-- Point font size
	alpha = 1,								-- Alpha transparency
	outline = 3,							-- Thin outline. 0 = no outline.
	shadow = {alpha = C.font.stats_font_shadow and 1 or 0, x = 1, y = -1},	-- Font shadow = 1
}

LTIPICONSIZE = 14							-- Icon sizes in info tips

LPSTAT_CONFIG = {
-- Bottomleft block
	Clock = {
		enabled = C.stats.clock, -- Local time and the 24 hour clock can be enabled in-game via time manager (right-click)
		AM = class"上午", PM = class"下午", colon = class":", -- These values apply to the displayed clock
		anchor_frame = "UIParent", anchor_to = "left", anchor_from = "bottomleft",
		x_off = 20, y_off = 11, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
	Latency = {
		enabled = C.stats.latency,
		fmt = "[color]%d|r"..class"ms", -- "77ms", [color] inserts latency color code
	 	anchor_frame = "Clock", anchor_to = "left", anchor_from = "right",
		x_off = C.stats.clock and 3 or 0, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
	FPS = {
		enabled = C.stats.fps,
		fmt = "%d"..class"帧", -- "42fps"
		max_addons = nil, -- Holding Alt reveals hidden addons
		anchor_frame = C.stats.latency and "Latency" or "Clock", anchor_to = "left", anchor_from = "right",
		x_off = 3, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
	Friends = {
		enabled = C.stats.friend,
		fmt = class"好友:".."%d/%d", -- "3/40F"
		maxfriends = nil, -- Set max friends listed, nil means no limit
		anchor_frame = C.stats.fps and "FPS" or C.stats.latency and "Latency" or "Clock", anchor_to = "left", anchor_from = "right",
		x_off = 3, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
	Guild = {
		enabled = C.stats.guild,
		fmt = class"公会:".."%d/%d", -- "5/114G"
		maxguild = nil, -- Set max members listed, nil means no limit. Alt-key reveals hidden members
		threshold = 1, -- Minimum level displayed (1-90)
		show_xp = true, -- Show guild experience
		sorting = "class", -- Default roster sorting: name, level, class, zone, rank, note
		anchor_frame = C.stats.friend and "Friends" or C.stats.fps and "FPS" or C.stats.latency and "Latency" or "Clock", anchor_to = "left", anchor_from = "right",
		x_off = 3, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
	Durability = {
		enabled = C.stats.durability,
		fmt = class"耐久:".."[color]%d|r%%", -- "54%D", [color] inserts durability color code
		man = true, -- Hide bliz durability man
		ignore_inventory = false, -- Ignore inventory gear when auto-repairing
		gear_icons = false, -- Show your gear icons in the tooltip
		anchor_frame = C.stats.guild and "Guild" or C.stats.friend and "Friends" or C.stats.fps and "FPS" or C.stats.latency and "Latency" or "Clock", anchor_to = "left", anchor_from = "right",
		x_off = 3, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
	Experience = {
		enabled = C.stats.experience,
			-- Experience & Played tags:
			--	Player Level [level]
			--	Current XP [curxp]				Max XP [totalxp]				Current/Max% [cur%]
			--	Remaining XP [remainingxp]		Remaining% [remaining%]
			--	Session Gained [sessiongained]	Session Rate [sessionrate]		Session Time To Level [sessionttl]
			--	Level Rate [levelrate]			Level Time To Level [levelttl]
			--	Rested XP [rest]				Rested/Level% [rest%]
			--	Quests To Level [questsleft]	Kills To Level [killsleft]
			--	Total Played [playedtotal]		Level Played [playedlevel]		Session Played [playedsession]
		xp_normal_fmt = class"经验:".."[cur%]%", -- XP string used when not rested.
		xp_rested_fmt = class"经验:".."[cur%]%"..class"双倍:".."[rest%]%", -- XP string used when rested
		played_fmt = class"在线:".."|r".."[playedsession]", -- Played time format
		short = true, thousand = "k", million = "m", billion = "b", -- Short numbers ("4.5m" "355.3k")
			-- Faction tags:
			--	Faction name [repname]
			--	Standing Color Code [repcolor]	Standing Name [standing]
			--	Current Rep [currep]			Current Rep Percent [rep%]
			--	Rep Left [repleft]				Max. Rep [maxrep]
		faction_fmt = "[repname]: [repcolor][currep]/[maxrep]|r",
		faction_subs = {
		--	["An Very Long Rep Name"] = "Shortened",
			["The Wyrmrest Accord"] = "Wyrmrest",
			["Knights of the Ebon Blade"] = "Ebon Blade",
			["Клан Громового Молота"] = "Громовой Молот",
			["Защитники Тол Барада"] = "Тол Барад",
			["Гидраксианские Повелители Вод"] = "Повелители Вод",
		},
		artifact_fmt = "[curart]([curart%]%)"..class"AP", -- Artifact power format
		anchor_frame = C.stats.durability and "Durability" or C.stats.guild and "Guild" or C.stats.friend and "Friends" or C.stats.fps and "FPS" or C.stats.latency and "Latency" or "Clock", anchor_to = "left", anchor_from = "right",
		x_off = 3, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMLEFT", tip_x = 21, tip_y = 20
	},
-- Bottomright block
	Coords = {
		enabled = C.stats.coords,
		fmt = "%d,%d",
		anchor_frame = "UIParent", anchor_to = "right", anchor_from = "bottomright",
		x_off = -17, y_off = 11
	},
	Location = {
		enabled = C.stats.location,
		subzone = true, -- Set to false to display the main zone's name instead of the subzone
		truncate = 0, -- Max number of letters for location text, set to 0 to disable
		coord_fmt = "%d,%d",
		anchor_frame = "Coords", anchor_to = "right", anchor_from = "left",
		x_off = C.stats.coords and -3 or 0, y_off = 0, tip_frame = "UIParent", tip_anchor = "BOTTOMRIGHT", tip_x = -21, tip_y = 20
	},
	Talents = {
		enabled = C.stats.talents,
		fmt = class"天赋:".."%0.6s",
		anchor_frame = C.stats.bags and "Bags" or "UIParent", anchor_to = "right", anchor_from = C.stats.bags and "left" or "bottomright",		
		x_off = C.stats.bags and -4 or -150, y_off = C.stats.bags and 0 or 11,
	},
	Stats = {
		enabled = C.stats.dps,
			-- Available stat tags:
			--	Power [power]	MP5 [manaregen]			Block [block]%			Avoidance [avoidance]%
			--	Haste [haste]%	Crit [crit]%			Mastery [mastery]%		Versatility [versatility]%
			--	Armor [armor]	Dodge [dodge]%			Parry [parry]%			Resilience [resilience]%
			--	Leech [leech]%
		--[[spec1fmt = class"强度: ".."[power]   "..class"暴击: ".."[crit]%"..class"  Haste: ".."[haste]%", -- Spec #1 string
		spec2fmt = class"强度: ".."[power]   "..class"暴击: ".."[crit]%"..class"  Haste: ".."[haste]%", -- Spec #2 string
		spec3fmt = class"强度: ".."[power]   "..class"暴击: ".."[crit]%"..class"  Haste: ".."[haste]%", -- Spec #3 string
		spec4fmt = class"强度: ".."[power]   "..class"暴击: ".."[crit]%"..class"  Haste: ".."[haste]%", -- Spec #4 string]]
		anchor_frame = C.stats.talents and "Talents" or C.stats.bags and "Bags" or "UIParent", anchor_to = "right", anchor_from = C.stats.talents and "left" or C.stats.bags and "left" or "bottomright",
		x_off = C.stats.bags and -4 or C.stats.talents and -4 or -150, y_off = C.stats.talents and 0 or C.stats.bags and 0 or 11,
	},
	Bags = {
		enabled = C.stats.bags,
		fmt = class"背包:".."%d/%d",
		anchor_frame = "UIParent", anchor_to = "right", anchor_from = "bottomright",
		x_off = -150, y_off = 11
	},
-- MiniMap block
	Ping = {
		enabled = true,
		fmt = "|cffff5555*|r %s |cffff5555*|r", -- "* PlayerName *"
		hide_self = true, -- Hide player's ping
		anchor_frame = "Minimap", anchor_to = "bottom", anchor_from = "bottom",
		x_off = 0, y_off = 5,
	},
-- Bags block
	Gold = {
		enabled = true,
		style = 1, -- Display styles: [1] 55g 21s 11c [2] 8829.4g [3] 823.55.94 [4] with texture
		anchor_frame = cBN and "NivayacBniv_Bag" or C.bag.enable and "StuffingFrameBags" or "Location",
		anchor_to = "right", anchor_from = cBN and "bottom" or C.bag.enable and "topright" or "left",
		x_off = cBN and 15 or C.bag.enable and -25 or -3,
		y_off = cBN and 8 or C.bag.enable and -13 or 0,
		tip_frame = cBN and "NivayacBniv_Bag" or C.bag.enable and "StuffingFrameBags" or "UIParent",
		tip_anchor = cBN and "TOPRIGHT" or C.bag.enable and "TOPRIGHT" or "BOTTOMRIGHT",
		tip_x = cBN and 0 or C.bag.enable and -50 or -21,
		tip_y = cBN and 85 or C.bag.enable and 0 or 20,
		strata = cBN and "DIALOG" or "MEDIUM"
	},
}

LPSTAT_PROFILES = {
	DRUID = {
		Stats = {
			-- Balance
			spec1fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Feral
			spec2fmt = class"护甲:".."[armor]  "..class"闪招格:".."[avoided]%  "..class"攻强:".."[power]",
			-- Restoration
			spec3fmt = class"治疗:".."[power]  "..class"暴击:".."[crit]%  "..class"回蓝:".."[manaregen]",
		}
	},
	HUNTER = {
		Stats = {
			-- Beast Mastery
			spec1fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Marksmanship
			spec2fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Survival
			spec3fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
		}
	},
	MAGE = {
		Stats = {
			-- Arcane
			spec1fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Fire
			spec2fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Frost
			spec3fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
		}
	},
	PALADIN = {
		Stats = {
			-- Holy
			spec1fmt = class"治疗:".."[power]  "..class"暴击:".."[crit]%  "..class"回蓝:".."[manaregen]",
			-- Protection
			spec2fmt = class"护甲:".."[armor]  "..class"闪招格:".."[avoided]%  "..class"攻强:".."[power]",
			-- Retribution
			spec3fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
		}
	},
	PRIEST = {
		Stats = {
			-- Discipline
			spec1fmt = class"治疗:".."[power]  "..class"暴击:".."[crit]%  "..class"回蓝:".."[manaregen]",
			-- Holy
			spec2fmt = class"治疗:".."[power]  "..class"暴击:".."[crit]%  "..class"回蓝:".."[manaregen]",
			-- Shadow
			spec3fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
		}
	},
	ROGUE = {
		Stats = {
			-- Assassination
			spec1fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Combat
			spec2fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Subtlety
			spec3fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
		}
	},
	SHAMAN = {
		Stats = {
			-- Elemental
			spec1fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Enhancement
			spec2fmt = class"攻强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Restoration
			spec3fmt = class"治疗:".."[power]  "..class"暴击:".."[crit]%  "..class"回蓝:".."[manaregen]",
		}
	},
	WARLOCK = {
		Stats = {
			-- Affliction
			spec1fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Demonology
			spec2fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
			-- Destruction
			spec3fmt = class"法强:".."[power]  "..class"暴击:".."[crit]%  "..class"命中:".."[hit]%",
		}
	},
	WARRIOR = {
		Stats = {
			-- Arms
			spec1fmt = class"攻强: ".."[power]  "..class"暴击: ".."[crit]%  "..class"命中: ".."[hit]%",
			-- Fury
			spec2fmt = class"攻强: ".."[power]  "..class"暴击: ".."[crit]%  "..class"命中: ".."[hit]%",
			-- Protection
			spec3fmt = class"护甲: ".."[armor]  "..class"闪招格: ".."[avoided]%  "..class"攻强: ".."[power]",
		}
	},
}
